/* do not edit automatically generated by mc from DynamicStringPath.  */
/* DynamicStringPath.def implements a path for DynamicStrings.

Copyright (C) 2001-2023 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

Under Section 7 of GPL version 3, you are granted additional
permissions described in the GCC Runtime Library Exception, version
3.1, as published by the Free Software Foundation.

You should have received a copy of the GNU General Public License and
a copy of the GCC Runtime Library Exception along with this program;
see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
<http://www.gnu.org/licenses/>.  */

#include "config.h"
#include "system.h"
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   if !defined (FALSE)
#      define FALSE (1==0)
#   endif

#   include "GStorage.h"
#if defined(__cplusplus)
#   undef NULL
#   define NULL 0
#endif
#define _DynamicStringPath_H
#define _DynamicStringPath_C

#   include "GStorage.h"
#   include "GDynamicStrings.h"
#   include "GSFIO.h"
#   include "GFIO.h"
#   include "GM2Printf.h"

#   define Directory '/'
#   define Debugging FALSE
typedef struct DynamicStringPath__T1_r DynamicStringPath__T1;

typedef DynamicStringPath__T1 *DynamicStringPath_PathList;

struct DynamicStringPath__T1_r {
                                 DynamicStringPath_PathList tail;
                                 DynamicStringPath_PathList next;
                                 DynamicStrings_String entry;
                               };

static DynamicStringPath_PathList FreeList;
static DynamicStringPath_PathList DefaultUserPath;
static DynamicStringPath_PathList DefaultSystemPath;

/*
   GetUserPath - returns the current UserPath.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_GetUserPath (void);

/*
   GetSystemPath - returns the current SystemPath.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_GetSystemPath (void);

/*
   SetUserPath - assigns UserPath to pl.
*/

extern "C" void DynamicStringPath_SetUserPath (DynamicStringPath_PathList pl);

/*
   SetSystemPath - assigns SystemPath to pl.
*/

extern "C" void DynamicStringPath_SetSystemPath (DynamicStringPath_PathList pl);

/*
   InitPathList - creates a new empty path list.
                  It takes a copy of the string.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_InitPathList (DynamicStrings_String str);

/*
   KillPathList - places list pl onto the freelist.
                  Postcondition: pl will be NIL.
*/

extern "C" void DynamicStringPath_KillPathList (DynamicStringPath_PathList *pl);

/*
   Cons - appends str to the end of a path list.
          If pl is NIL a new list is created and returned
          containing str.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_Cons (DynamicStringPath_PathList pl, DynamicStrings_String str);

/*
   ConsList - concatenates path list left and right together.
              It always returns NIL which should be assigned
              to the callers right parameter after ConsList
              has been completed signifying that right should
              no longer be accessed.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_ConsList (DynamicStringPath_PathList left, DynamicStringPath_PathList right);

/*
   Stash - returns pl before setting pl to NIL.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_Stash (DynamicStringPath_PathList *pl);

/*
   FindFileName - returns NIL if a file cannot be found otherwise
                  it returns the path including the filename.
*/

extern "C" DynamicStrings_String DynamicStringPath_FindFileName (DynamicStrings_String filename, DynamicStringPath_PathList pl);

/*
   AddDir - if str is not empty and does not end with / then add
            a directory.
            Postcondition: str is returned (with a '/' at the end)
            or is empty.
*/

static DynamicStrings_String AddDir (DynamicStrings_String str);

/*
   DumpPath - debugging dump of the pathlist.
*/

static void DumpPath (const char *name_, unsigned int _name_high, DynamicStringPath_PathList pl);


/*
   AddDir - if str is not empty and does not end with / then add
            a directory.
            Postcondition: str is returned (with a '/' at the end)
            or is empty.
*/

static DynamicStrings_String AddDir (DynamicStrings_String str)
{
  if ((DynamicStrings_Length (str)) > 0)
    {
      if ((DynamicStrings_char (str, -1)) != Directory)
        {
          str = DynamicStrings_ConCatChar (str, Directory);
        }
    }
  return str;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   DumpPath - debugging dump of the pathlist.
*/

static void DumpPath (const char *name_, unsigned int _name_high, DynamicStringPath_PathList pl)
{
  char name[_name_high+1];

  /* make a local copy of each unbounded array.  */
  memcpy (name, name_, _name_high+1);

  if (Debugging)
    {
      M2Printf_fprintf0 (FIO_StdErr, (const char *) name, _name_high);
      M2Printf_fprintf0 (FIO_StdErr, (const char *) ":", 1);
      while (pl != NULL)
        {
          M2Printf_fprintf0 (FIO_StdErr, (const char *) " {", 2);
          M2Printf_fprintf1 (FIO_StdErr, (const char *) "%s", 2, (const unsigned char *) &pl->entry, (sizeof (pl->entry)-1));
          M2Printf_fprintf0 (FIO_StdErr, (const char *) "}", 1);
          pl = pl->next;
        }
      M2Printf_fprintf0 (FIO_StdErr, (const char *) "\\n", 2);
    }
}


/*
   GetUserPath - returns the current UserPath.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_GetUserPath (void)
{
  return DefaultUserPath;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   GetSystemPath - returns the current SystemPath.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_GetSystemPath (void)
{
  return DefaultSystemPath;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   SetUserPath - assigns UserPath to pl.
*/

extern "C" void DynamicStringPath_SetUserPath (DynamicStringPath_PathList pl)
{
  DefaultUserPath = pl;
  DumpPath ((const char *) "DefaultUserPath", 15, DefaultUserPath);
}


/*
   SetSystemPath - assigns SystemPath to pl.
*/

extern "C" void DynamicStringPath_SetSystemPath (DynamicStringPath_PathList pl)
{
  DefaultSystemPath = pl;
  DumpPath ((const char *) "DefaultSystemPath", 17, DefaultSystemPath);
}


/*
   InitPathList - creates a new empty path list.
                  It takes a copy of the string.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_InitPathList (DynamicStrings_String str)
{
  DynamicStringPath_PathList pl;

  Storage_ALLOCATE ((void **) &pl, sizeof (DynamicStringPath__T1));
  pl->tail = pl;
  pl->next = NULL;
  pl->entry = DynamicStrings_Dup (str);
  return pl;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   KillPathList - places list pl onto the freelist.
                  Postcondition: pl will be NIL.
*/

extern "C" void DynamicStringPath_KillPathList (DynamicStringPath_PathList *pl)
{
  if ((*pl) != NULL)
    {
      (*pl)->tail->next = FreeList;
      FreeList = (*pl);
      (*pl) = NULL;
    }
}


/*
   Cons - appends str to the end of a path list.
          If pl is NIL a new list is created and returned
          containing str.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_Cons (DynamicStringPath_PathList pl, DynamicStrings_String str)
{
  if (pl == NULL)
    {
      pl = DynamicStringPath_InitPathList (str);
    }
  else
    {
      pl = DynamicStringPath_ConsList (pl, DynamicStringPath_InitPathList (str));
    }
  return pl;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   ConsList - concatenates path list left and right together.
              It always returns NIL which should be assigned
              to the callers right parameter after ConsList
              has been completed signifying that right should
              no longer be accessed.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_ConsList (DynamicStringPath_PathList left, DynamicStringPath_PathList right)
{
  if (right != NULL)
    {
      left->tail->next = right;
      left->tail = right->tail;
    }
  return left;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   Stash - returns pl before setting pl to NIL.
*/

extern "C" DynamicStringPath_PathList DynamicStringPath_Stash (DynamicStringPath_PathList *pl)
{
  DynamicStringPath_PathList old;

  old = (*pl);
  (*pl) = NULL;
  return old;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   FindFileName - returns NIL if a file cannot be found otherwise
                  it returns the path including the filename.
*/

extern "C" DynamicStrings_String DynamicStringPath_FindFileName (DynamicStrings_String filename, DynamicStringPath_PathList pl)
{
  DynamicStrings_String s;

  while (pl != NULL)
    {
      s = DynamicStrings_ConCat (AddDir (DynamicStrings_Dup (pl->entry)), DynamicStrings_Dup (filename));
      if (Debugging)
        {
          M2Printf_fprintf1 (FIO_StdErr, (const char *) "testing for %s: ", 16, (const unsigned char *) &s, (sizeof (s)-1));
        }
      if (SFIO_Exists (s))
        {
          if (Debugging)
            {
              M2Printf_fprintf0 (FIO_StdErr, (const char *) "yes\\n", 5);
            }
          return s;
        }
      if (Debugging)
        {
          M2Printf_fprintf0 (FIO_StdErr, (const char *) "no\\n", 4);
        }
      s = DynamicStrings_KillString (s);
      pl = pl->next;
    }
  if (Debugging)
    {
      M2Printf_fprintf1 (FIO_StdErr, (const char *) "FindFileName did not find: %s in path\\n", 39, (const unsigned char *) &filename, (sizeof (filename)-1));
    }
  return static_cast<DynamicStrings_String> (NULL);
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}

extern "C" void _M2_DynamicStringPath_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
  DefaultSystemPath = NULL;
  DefaultUserPath = NULL;
  FreeList = NULL;
}

extern "C" void _M2_DynamicStringPath_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
}
